Loading...
Searching...
No Matches
casacore::MatrixMath_global_functions_Linear_Algebra Struct Reference
casa package (libcasa_casa) » Arrays_module

More...

`#include <MatrixMath.h>`

## Public Member Functions

template<class T>
T | innerProduct (const Vector< T > &x, const Vector< T > &y)
| The scalar/dot/inner product of two equal length vectors.
std::complex< float > | innerProduct (const Vector< std::complex< float > > &x, const Vector< std::complex< float > > &y)
std::complex< double > | innerProduct (const Vector< std::complex< double > > &x, const Vector< std::complex< double > > &y)
int | norm (const Vector< int > &x)
| The magnitude/norm of a vector.
float | norm (const Vector< float > &x)
double | norm (const Vector< double > &x)
float | norm (const Vector< std::complex< float > > &x)
double | norm (const Vector< std::complex< double > > &x)
template<class T>
Vector< T > | crossProduct (const Vector< T > &x, const Vector< T > &y)
| The vector/cross product of two 3-space vectors.
template<class T>
T | crossProduct2D (const Vector< T > &x, const Vector< T > &y)
| Magnitude of cross product of two 2-space vectors, x[0]*y[1] - x[1]*y[0].
template<class T>
Matrix< T > | product (const Vector< T > &x, const Matrix< T > &yT)
| The matrix/outer product of a vector and a transposed vector.
template<class T>
Vector< T > | product (const Matrix< T > &A, const Vector< T > &x)
| The vector/outer product of an MxN matrix and an N-length vector.
template<class T>
Vector< T > | directProduct (const Vector< T > &x, const Vector< T > &y)
| The direct product of two vectors.
template<class T>
Matrix< T > | product (const Matrix< T > &A, const Matrix< T > &B)
| The matrix multiplication or cayley product of an MxN matrix and an NxP matrix.
int | normI (const Matrix< int > &A)
| The infinity norm (or maximum value of the sum of the absolute values of the rows members of a matrix).
float | normI (const Matrix< float > &A)
double | normI (const Matrix< double > &A)
float | normI (const Matrix< std::complex< float > > &A)
double | normI (const Matrix< std::complex< double > > &A)
int | norm1 (const Matrix< int > &A)
| The one norm (or maximum value of the sum of the absolute values of the column members of a matrix).
float | norm1 (const Matrix< float > &A)
double | norm1 (const Matrix< double > &A)
float | norm1 (const Matrix< std::complex< float > > &A)
double | norm1 (const Matrix< std::complex< double > > &A)
template<class T>
Matrix< T > | transpose (const Matrix< T > &A)
| The NxM transpose of an MxN matrix.
template<class T>
Matrix< T > | Rot3D (int axis, T angle)
| Create a 3D rotation matrix (3x3).
Matrix< double > | Rot3D (int axis, double angle)
Matrix< float > | Rot3D (int axis, float angle)
template<class T>
Matrix< T > | directProduct (const Matrix< T > &A, const Matrix< T > &B)
| The direct product of two matrices.
Matrix< std::complex< float > > | adjoint (const Matrix< std::complex< float > > &A)
| The conjugate/transpose or adjoint of the complex matrix A.
Matrix< std::complex< double > > | adjoint (const Matrix< std::complex< double > > &A)
Matrix< int > | adjoint (const Matrix< int > &A)
| define the adjoint operator as a plain old transpose when the Matrix is not complex valued.
Matrix< float > | adjoint (const Matrix< float > &A)
Matrix< double > | adjoint (const Matrix< double > &A)
Vector< std::complex< float > > | product (const Matrix< std::complex< float > > &, const Vector< float > &)
| The product of a std::complex<float> Matrix and a Real Vector.
Vector< float > | rproduct (const Matrix< std::complex< float > > &, const Vector< std::complex< float > > &)
| The real part of a product of a std::complex<float> Matrix and a std::complex<float> Vector.
Matrix< float > | rproduct (const Matrix< std::complex< float > > &, const Matrix< std::complex< float > > &)
| The real part of a product of a std::complex<float> Matrix and a std::complex<float> Matrix.

## Detailed Description

Linear algebra functions on Vectors and Matrices.

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tLinAlgebra

Definition at line 47 of file MatrixMath.h.

## Member Function Documentation

## adjoint() [1/5]

Matrix< double > casacore::MatrixMath_global_functions_Linear_Algebra::adjoint | ( | const Matrix< double > & | A | ) |

## adjoint() [2/5]

Matrix< float > casacore::MatrixMath_global_functions_Linear_Algebra::adjoint | ( | const Matrix< float > & | A | ) |

## adjoint() [3/5]

Matrix< int > casacore::MatrixMath_global_functions_Linear_Algebra::adjoint | ( | const Matrix< int > & | A | ) |

define the adjoint operator as a plain old transpose when the Matrix is not complex valued.

(for templating purposes)

## adjoint() [4/5]

Matrix< std::complex< double > > casacore::MatrixMath_global_functions_Linear_Algebra::adjoint | ( | const Matrix< std::complex< double > > & | A | ) |

## adjoint() [5/5]

Matrix< std::complex< float > > casacore::MatrixMath_global_functions_Linear_Algebra::adjoint | ( | const Matrix< std::complex< float > > & | A | ) |

The conjugate/transpose or adjoint of the complex matrix A.

## crossProduct()

template<class T>

Vector< T > casacore::MatrixMath_global_functions_Linear_Algebra::crossProduct | ( | const Vector< T > & | x,
|  | const Vector< T > & | y )

The vector/cross product of two 3-space vectors.

## crossProduct2D()

template<class T>

T casacore::MatrixMath_global_functions_Linear_Algebra::crossProduct2D | ( | const Vector< T > & | x,
|  | const Vector< T > & | y )

Magnitude of cross product of two 2-space vectors, x[0]*y[1] - x[1]*y[0].

## directProduct() [1/2]

template<class T>

Matrix< T > casacore::MatrixMath_global_functions_Linear_Algebra::directProduct | ( | const Matrix< T > & | A,
|  | const Matrix< T > & | B )

The direct product of two matrices.

The resulting matrix contains for every element of A, the product of that element and Matrix B. Thus the shape of the output matrix is the (element by element) product of the input shapes.

## directProduct() [2/2]

template<class T>

Vector< T > casacore::MatrixMath_global_functions_Linear_Algebra::directProduct | ( | const Vector< T > & | x,
|  | const Vector< T > & | y )

The direct product of two vectors.

The resulting vector contains for every element of x, the product of that element and Vector y. Thus the length of the output vector is the product of the input lengths.

## innerProduct() [1/3]

std::complex< double > casacore::MatrixMath_global_functions_Linear_Algebra::innerProduct | ( | const Vector< std::complex< double > > & | x,
|  | const Vector< std::complex< double > > & | y )

## innerProduct() [2/3]

std::complex< float > casacore::MatrixMath_global_functions_Linear_Algebra::innerProduct | ( | const Vector< std::complex< float > > & | x,
|  | const Vector< std::complex< float > > & | y )

## innerProduct() [3/3]

template<class T>

T casacore::MatrixMath_global_functions_Linear_Algebra::innerProduct | ( | const Vector< T > & | x,
|  | const Vector< T > & | y )

The scalar/dot/inner product of two equal length vectors.

## norm() [1/5]

double casacore::MatrixMath_global_functions_Linear_Algebra::norm | ( | const Vector< double > & | x | ) |

## norm() [2/5]

float casacore::MatrixMath_global_functions_Linear_Algebra::norm | ( | const Vector< float > & | x | ) |

## norm() [3/5]

int casacore::MatrixMath_global_functions_Linear_Algebra::norm | ( | const Vector< int > & | x | ) |

The magnitude/norm of a vector.

## norm() [4/5]

double casacore::MatrixMath_global_functions_Linear_Algebra::norm | ( | const Vector< std::complex< double > > & | x | ) |

## norm() [5/5]

float casacore::MatrixMath_global_functions_Linear_Algebra::norm | ( | const Vector< std::complex< float > > & | x | ) |

## norm1() [1/5]

double casacore::MatrixMath_global_functions_Linear_Algebra::norm1 | ( | const Matrix< double > & | A | ) |

## norm1() [2/5]

float casacore::MatrixMath_global_functions_Linear_Algebra::norm1 | ( | const Matrix< float > & | A | ) |

## norm1() [3/5]

int casacore::MatrixMath_global_functions_Linear_Algebra::norm1 | ( | const Matrix< int > & | A | ) |

The one norm (or maximum value of the sum of the absolute values of the column members of a matrix).

## norm1() [4/5]

double casacore::MatrixMath_global_functions_Linear_Algebra::norm1 | ( | const Matrix< std::complex< double > > & | A | ) |

## norm1() [5/5]

float casacore::MatrixMath_global_functions_Linear_Algebra::norm1 | ( | const Matrix< std::complex< float > > & | A | ) |

## normI() [1/5]

double casacore::MatrixMath_global_functions_Linear_Algebra::normI | ( | const Matrix< double > & | A | ) |

## normI() [2/5]

float casacore::MatrixMath_global_functions_Linear_Algebra::normI | ( | const Matrix< float > & | A | ) |

## normI() [3/5]

int casacore::MatrixMath_global_functions_Linear_Algebra::normI | ( | const Matrix< int > & | A | ) |

The infinity norm (or maximum value of the sum of the absolute values of the rows members of a matrix).

## normI() [4/5]

double casacore::MatrixMath_global_functions_Linear_Algebra::normI | ( | const Matrix< std::complex< double > > & | A | ) |

## normI() [5/5]

float casacore::MatrixMath_global_functions_Linear_Algebra::normI | ( | const Matrix< std::complex< float > > & | A | ) |

## product() [1/4]

Vector< std::complex< float > > casacore::MatrixMath_global_functions_Linear_Algebra::product | ( | const Matrix< std::complex< float > > & | ,
|  | const Vector< float > & | )

The product of a std::complex<float> Matrix and a Real Vector.

## product() [2/4]

template<class T>

Matrix< T > casacore::MatrixMath_global_functions_Linear_Algebra::product | ( | const Matrix< T > & | A,
|  | const Matrix< T > & | B )

The matrix multiplication or cayley product of an MxN matrix and an NxP matrix.

## product() [3/4]

template<class T>

Vector< T > casacore::MatrixMath_global_functions_Linear_Algebra::product | ( | const Matrix< T > & | A,
|  | const Vector< T > & | x )

The vector/outer product of an MxN matrix and an N-length vector.

## product() [4/4]

template<class T>

Matrix< T > casacore::MatrixMath_global_functions_Linear_Algebra::product | ( | const Vector< T > & | x,
|  | const Matrix< T > & | yT )

The matrix/outer product of a vector and a transposed vector.

Note: The function's second argument is actually a transposed vector stored as the only row in a 1xN matrix;

## Rot3D() [1/3]

Matrix< double > casacore::MatrixMath_global_functions_Linear_Algebra::Rot3D | ( | int | axis,
|  | double | angle )

## Rot3D() [2/3]

Matrix< float > casacore::MatrixMath_global_functions_Linear_Algebra::Rot3D | ( | int | axis,
|  | float | angle )

## Rot3D() [3/3]

template<class T>

Matrix< T > casacore::MatrixMath_global_functions_Linear_Algebra::Rot3D | ( | int | axis,
|  | T | angle )

Create a 3D rotation matrix (3x3).

Axis is 0,1,2 for x,y,z; angle is in radians.

## rproduct() [1/2]

Matrix< float > casacore::MatrixMath_global_functions_Linear_Algebra::rproduct | ( | const Matrix< std::complex< float > > & | ,
|  | const Matrix< std::complex< float > > & | )

The real part of a product of a std::complex<float> Matrix and a std::complex<float> Matrix.

## rproduct() [2/2]

Vector< float > casacore::MatrixMath_global_functions_Linear_Algebra::rproduct | ( | const Matrix< std::complex< float > > & | ,
|  | const Vector< std::complex< float > > & | )

The real part of a product of a std::complex<float> Matrix and a std::complex<float> Vector.

## transpose()

template<class T>

Matrix< T > casacore::MatrixMath_global_functions_Linear_Algebra::transpose | ( | const Matrix< T > & | A | ) |

The NxM transpose of an MxN matrix.

The documentation for this struct was generated from the following file:

- casa/Arrays/MatrixMath.h